<template>
  <div id="app">
    <div class="Column is-half is-offset-one-quarter">
      <img src="./assets/logo-leaf.png">
      <hr>
      <h4 class="is-size-4">Pokedexx</h4>
      <br>
      <input type="text" class="input is-rounded" name="" id="" v-model="dtBusca" placeholder="Busca Pokémon pelo nome">
      <button class="button is-fullwidth is-success" id="buscaBtn" @click="Buscar">Buscar</button>
      <div>
        <div v-for="(p, i) in lstFilteredPokemon" :key="p.url">
          <Pokemon :propName="p.name" :propUrl="p.url" :num="i+1"/><br>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import axios from 'axios';
import Pokemon from './components/Pokemon';

export default {
  name: 'App',
  data() {
    return {
      lstPokemon: [],
      lstFilteredPokemon: [],
      dtBusca: ''
    }
  },
  created: function(){
    //Executado toda vez que o componente é criado no hrml
    var urlBase = "https://pokeapi.co/api/v2/";
    axios.get(urlBase + "pokemon?limit=151&offset=0").then(res => {
      //É importante ver como a resposta está chegando para saber como obter os dados desejados
      //console.log(res);
      //Neste caso, apenas a lista de pokémon
      //console.log(res.data.results);
      this.lstPokemon = res.data.results;
      this.lstFilteredPokemonPokemon = res.data.results;
    });
  },
  components: {
    Pokemon
  },
  methods: {
    Buscar: function(){
      this.lstFilteredPokemon = this.lstPokemon;
      if(this.dtBusca == '' || this.dtBusca == ' '){
        this.lstFilteredPokemon = this.lstPokemon;
      }else{
        this.lstFilteredPokemon = this.lstPokemon.filter(p => p.name == this.dtBusca);
      }
    }
  },
  computed: {
    /*resultadoBusca: function(){
      if(this.dtBusca == '' || this.dtBusca == ' '){
        return this.lstPokemon;
      }else{
        return this.lstPokemon.filter(p => p.name == this.dtBusca);
      }
    }*/
  }
}
</script>

<style>
#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 60px;
}

#buscaBtn{
  margin-top: 2%;
}
</style>
